package com.api.browser.service.impl;

import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SplitTableBean;
import com.api.browser.bean.SplitTableColBean;
import com.api.browser.service.BrowserService;
import com.api.browser.util.*;
import weaver.general.Util;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 职务类别
 * 
 * @author lvyi
 * 
 */
public class JobGroupsBrowserService extends BrowserService {

	@Override
	public Map<String, Object> getBrowserData(Map<String, Object> params) throws Exception {
		Map<String, Object> apidatas = new HashMap<String, Object>();
		String jobgroupremark = Util.null2String(params.get("jobgroupremark"));
		String jobgroupname = Util.null2String(params.get("jobgroupname"));
		String sqlwhere = "where 1 = 1 ";
		String backfields = "";
		String fromSql = "";
		String orderby = "";
		if(!jobgroupremark.equals("")){
			sqlwhere += " and jobgroupremark like '%";
			sqlwhere += Util.fromScreen2(jobgroupremark,user.getLanguage());
			sqlwhere += "%'";
		}
		if(!jobgroupname.equals("")){
			sqlwhere += " and jobgroupname like '%";
			sqlwhere += Util.fromScreen2(jobgroupname,user.getLanguage());
			sqlwhere += "%'";
		}

		List<SplitTableColBean> cols = new ArrayList<SplitTableColBean>();
		backfields = " t.id, t.jobgroupname, t.jobgroupremark, t.jobgroupdesc ";
		fromSql = " (SELECT " +
				" a.id, " +
				" a.jobgroupname, " +
				" a.jobgroupremark, " +
				" b.jobgroupdesc  " +
				"FROM " +
				" HrmJobGroups a " +
				" LEFT JOIN uf_jobgroupdesc b ON b.jobgroup = a.id ) t";
		orderby = " id ";

		cols.add(new SplitTableColBean("true", "id"));
//		SplitTableColBean splitTableColBean = new SplitTableColBean("35%", SystemEnv.getHtmlLabelName(399, user.getLanguage()), "jobgroupremark", "jobgroupremark");
		SplitTableColBean splitTableColBean = new SplitTableColBean("50%", SystemEnv.getHtmlLabelName(15767, user.getLanguage()), "jobgroupname", "jobgroupname");
		splitTableColBean.setOrderkey("");
		splitTableColBean.setIsInputCol(BoolAttr.TRUE);
		cols.add(splitTableColBean.setIsInputCol(BoolAttr.TRUE));
		cols.add(new SplitTableColBean("50%", SystemEnv.getHtmlLabelName(433, user.getLanguage()), "jobgroupdesc", "jobgroupdesc"));//二开

		SplitTableBean tableBean = new SplitTableBean(backfields, fromSql, sqlwhere, orderby, "id", cols);
		
		tableBean.setSqlsortway("ASC");
		//tableBean.setSqlisdistinct("true");
		apidatas.putAll(SplitTableUtil.makeListDataResult(tableBean));
		return apidatas;
	}

	@Override
	public Map<String, Object> getBrowserConditionInfo(Map<String, Object> params) throws Exception {
		Map<String, Object> apidatas = new HashMap<String, Object>();
		List<SearchConditionItem> conditions = new ArrayList<SearchConditionItem>();
		apidatas.put(BrowserConstant.BROWSER_RESULT_CONDITIONS, conditions);
		ConditionFactory conditionFactory = new ConditionFactory(user);
		conditions.add(conditionFactory.createCondition(ConditionType.INPUT, 399, "jobgroupremark", true));
		conditions.add(conditionFactory.createCondition(ConditionType.INPUT, 15767, "jobgroupname"));
		return apidatas;
	}

}
