package com.api.browser.service.impl;

import com.api.browser.bean.ListHeadBean;
import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SplitTableBean;
import com.api.browser.bean.SplitTableColBean;
import com.api.browser.service.BrowserService;
import com.api.browser.util.*;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 办公地点
 * 
 * @author jhy Mar 28, 2017
 * 
 */
public class LocationBrowserService extends BrowserService {

	@Override
	public Map<String, Object> getBrowserData(Map<String, Object> params) throws Exception {
		// TODO Auto-generated method stub
		Map<String, Object> apidatas = new HashMap<String, Object>();
		String locationname = Util.null2String(params.get("locationname"));
		String locationdesc = Util.null2String(params.get("locationdesc"));
		String address = Util.null2String(params.get("address"));
		String sqlwhere = " where 1 = 1 ";
		if (!locationname.equals("")) {
			sqlwhere += " and locationname like '%";
			sqlwhere += Util.fromScreen2(locationname, user.getLanguage());
			sqlwhere += "%'";
		}
		if (!locationdesc.equals("")) {
			sqlwhere += " and locationdesc like '%";
			sqlwhere += Util.fromScreen2(locationdesc, user.getLanguage());
			sqlwhere += "%'";
		}
		if (!address.equals("")) {
			sqlwhere += " and (address1 like '%";
			sqlwhere += Util.fromScreen2(address, user.getLanguage());
			sqlwhere += "%')";
		}
		// 设置好搜索条件
		String backFields = " id ,locationname,locationdesc,address1 ";
		String fromSql = " HrmLocations ";
		String orderBy = " showOrder,id ";
		
		List<SplitTableColBean> cols = new ArrayList<SplitTableColBean>();
		cols.add(new SplitTableColBean("15%",SystemEnv.getHtmlLabelName(84, user.getLanguage()),"id","id"));
//		cols.add(new SplitTableColBean("25%",SystemEnv.getHtmlLabelName(399, user.getLanguage()),"locationname","locationname"));
		cols.add(new SplitTableColBean("35%",SystemEnv.getHtmlLabelName(15767, user.getLanguage()),"locationdesc","locationdesc").setIsInputCol(BoolAttr.TRUE));
		cols.add(new SplitTableColBean("50%",SystemEnv.getHtmlLabelName(110, user.getLanguage()),"address1","address1"));
		
		SplitTableBean tableBean  =  new SplitTableBean(backFields,fromSql,sqlwhere,orderBy,"id",cols);
		tableBean.setSqlsortway("ASC");
		apidatas.putAll(SplitTableUtil.makeListDataResult(tableBean));
		return apidatas;
	}


	@Override
	public Map<String, Object> getBrowserConditionInfo(Map<String, Object> params) throws Exception {
		Map<String, Object> apidatas = new HashMap<String, Object>();
		List<SearchConditionItem> conditions = new ArrayList<SearchConditionItem>();
		ConditionFactory conditionFactory = new ConditionFactory(user);
		conditions.add(conditionFactory.createCondition(ConditionType.INPUT, 399, "locationname",true));
		conditions.add(conditionFactory.createCondition(ConditionType.INPUT, 15767, "locationdesc"));
		conditions.add(conditionFactory.createCondition(ConditionType.INPUT, 110, "address"));
		apidatas.put(BrowserConstant.BROWSER_RESULT_CONDITIONS,conditions);
		return apidatas;
	}

	@Override
	public Map<String, Object> getMultBrowserDestData(Map<String, Object> params) throws Exception {
		Map<String, Object> apidatas = new HashMap<String, Object>();
		List<Map<String,Object>> datas  = new ArrayList<Map<String,Object>>();
		String selectids = Util.null2String(params.get(BrowserConstant.BROWSER_MULT_DEST_SELECTIDS));
		if(user == null || "".equals(selectids)) return apidatas;
		RecordSet rs  = new RecordSet();
		String tempSql  = "select id,locationname,locationdesc from HrmLocations where id in ("+selectids+")";
		rs.executeQuery(tempSql);
		while(rs.next()){
			Map<String,Object> item = new HashMap<>();
			item.put("id", rs.getString("id"));
			item.put("locationname", Util.null2String(rs.getString("locationname")));
			item.put("locationdesc", Util.null2String(rs.getString("locationdesc")));
			datas.add(item);
		}
//		LocationComInfo locationComInfo=new LocationComInfo();
//		String[] ids = Util.splitString(selectids, ",");
//		for(int i=0;i<ids.length;i++){
//			String id = Util.null2String(ids[i]);
//			if(id.length()==0)continue;
//			Map<String,Object> item = new HashMap<String,Object>();
//			item.put("id", id);
//			item.put("locationname", Util.null2String(locationComInfo.getLocationname(id)));
//			item.put("locationdesc", Util.null2String(locationComInfo.getLocationname(id)));
//			datas.add(item);
//		}

		List<ListHeadBean> tableHeadColumns =  new ArrayList<ListHeadBean>();
		tableHeadColumns.add(new ListHeadBean("id",BoolAttr.TRUE));
		tableHeadColumns.add(new ListHeadBean("locationname","",1,BoolAttr.TRUE));
		tableHeadColumns.add(new ListHeadBean("locationdesc",""));

		apidatas.put(BrowserConstant.BROWSER_RESULT_COLUMN, tableHeadColumns);
		apidatas.put(BrowserConstant.BROWSER_RESULT_DATA, datas);
		apidatas.put(BrowserConstant.BROWSER_RESULT_TYPE, BrowserDataType.LIST_ALL_DATA.getTypeid());
		return apidatas;
	}
}
