package com.api.hrm.cmd.search;

import com.api.hrm.util.ServiceUtil;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 获取人员定制过的查询条件模板列表
 */
public class GetHrmSearchMoudleListCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetHrmSearchMoudleListCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> resultMap = new HashMap<String, Object>();
        try {
            String userId = Util.null2String(params.get("userid"));
            //左侧组织结构树选择的维度：默认为1--组织维度
            int virtualType = Util.getIntValue((String) params.get("virtualtype"), 1);
            if (userId.length() == 0) {
                userId = "" + user.getUID();
            }

            RecordSet rs = new RecordSet();
            List<Map<String, Object>> lsMould = new ArrayList<Map<String, Object>>();
            Map<String, Object> mouldInfo = null;
            //默认显示【全部人员】查询模板
            mouldInfo = new HashMap<String, Object>();
            mouldInfo.put("typeid", "default_3");
            mouldInfo.put("title", SystemEnv.getHtmlLabelName(381958, user.getLanguage()));
            mouldInfo.put("editable", false);
            lsMould.add(mouldInfo);

            //仅当左侧组织结构树选择非虚拟维度时才存在以下查询模板
            if (virtualType > 0) {
                //是否是系统管理员或分权管理员，如果不是，显示【同部门】查询模板
                if (!ServiceUtil.isAdmin(userId)) {
                    mouldInfo = new HashMap<String, Object>();
                    mouldInfo.put("typeid", "default_1");
                    mouldInfo.put("title", SystemEnv.getHtmlLabelName(18511, user.getLanguage()));
                    mouldInfo.put("editable", false);
                    lsMould.add(mouldInfo);
                }

                //是否存在下属，若存在，显示【我的下属】查询模板
                rs.executeSql("select count(1) from hrmresource where managerid=" + userId);
                if (rs.next()) {
                    if (rs.getInt(1) > 0) {
                        mouldInfo = new HashMap<String, Object>();
                        mouldInfo.put("typeid", "default_2");
                        mouldInfo.put("title", SystemEnv.getHtmlLabelName(15089, user.getLanguage()));
                        mouldInfo.put("editable", false);
                        lsMould.add(mouldInfo);
                    }
                }

                //是否存在自定义的查询模板
                rs.executeSql("select id, mouldname from HrmSearchMould where userId=" + userId + " order by id ");
                while (rs.next()) {
                    mouldInfo = new HashMap<String, Object>();
                    mouldInfo.put("typeid", rs.getString("id"));
                    mouldInfo.put("title", rs.getString("mouldname"));
                    mouldInfo.put("editable", true);
                    lsMould.add(mouldInfo);
                }

                //二开--通讯录给所有人增加同部门及其下级部门tab
                BaseBean basebean = new BaseBean();
                String contactsTabId = basebean.getPropValue("project_sskj", "contactsTabId");
                String contactsTabName =  SystemEnv.getHtmlLabelName(125591, user.getLanguage());//同部门以及下级部门
                mouldInfo = new HashMap<String, Object>();
                mouldInfo.put("typeid", contactsTabId);
                mouldInfo.put("title", contactsTabName);
                mouldInfo.put("editable", false);
                lsMould.add(mouldInfo);

            }
            resultMap.put("status", "1");
            resultMap.put("tabs", lsMould);
        } catch (Exception e) {
            resultMap.put("status", "-1");
            resultMap.put("message", ""+ SystemEnv.getHtmlLabelName(10004502,weaver.general.ThreadVarLanguage.getLang())+"tabs"+ SystemEnv.getHtmlLabelName(32104,weaver.general.ThreadVarLanguage.getLang())+"");
            writeLog(e);
        }
        return resultMap;
    }
}
