package com.customization.sskj;

import com.customization.sskj.util.JobGroupUtil;
import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.hrm.cmd.jobset.AddJobGroupCmd;
import com.engine.hrm.cmd.jobset.EditJobGroupCmd;
import org.apache.commons.lang.StringUtils;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.Map;

/**
 * 编制岗位类别保存
 */
@CommandDynamicProxy(target = AddJobGroupCmd.class, desc = "AddJobGroupCmd")
public class AddJobGroupCmdInter extends AbstractCommandProxy<Map<String, Object>> {

    BaseBean basebean = new BaseBean();
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> command) {

        AddJobGroupCmd cmd = (AddJobGroupCmd) command;
        User user = cmd.getUser();
        Map<String, Object> params = cmd.getParams();
        Map<String, Object> result = nextExecute(cmd);

        String sign = Util.null2String(result.get("sign"));
        if ( !StringUtils.isEmpty(sign)) {
            String jobgroupremark = Util.null2String(params.get("jobgroupremark"));
            String jobGroupDesc = Util.null2String(params.get("jobgroupdesc"));
            if ( !StringUtils.isEmpty(jobgroupremark)) {
                JobGroupUtil jobGroupUtil = new JobGroupUtil();
                Map< String, Object> getResult = jobGroupUtil.getJobGroupId(jobgroupremark);
                String code = Util.null2String( getResult.get("code"));
                if ("200".equals(code)) {
                    String jobGroupId = Util.null2String(getResult.get("data"));
                    boolean addFlag = jobGroupUtil.addJobGroupDesc(jobGroupId, jobGroupDesc, user);
                    basebean.writeLog("AddJobGroupCmdInter addFlag: " + addFlag);
                } else {
                    basebean.writeLog("AddJobGroupCmdInter code: " + code);
                    String msg = Util.null2String( getResult.get("msg"));
                    basebean.writeLog("AddJobGroupCmdInter msg: " + msg);
                }

            } else {
                basebean.writeLog("AddJobGroupCmdInter jobgroupremark is null");
            }
        } else {
            basebean.writeLog("AddJobGroupCmdInter sign: " + sign);
        }


        return result;
    }
}
