package com.customization.sskj;

import cn.hutool.core.date.DateUtil;
import com.api.prj.cmd.task.GetTaskFormItemCmd;
import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.kq.cmd.myattendance.GetHrmKQMonthReportInfoCmd;
import org.apache.commons.lang.StringUtils;
import weaver.general.Util;

import java.time.LocalDate;
import java.time.YearMonth;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

@CommandDynamicProxy(target = GetHrmKQMonthReportInfoCmd.class, desc = "GetHrmKQMonthReportInfoCmd")
public class GetHrmKQMonthReportInfoCmdInter extends AbstractCommandProxy<Map<String, Object>> {
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> command) {

        GetHrmKQMonthReportInfoCmd cmd = (GetHrmKQMonthReportInfoCmd) command;
        Map<String, Object> params = cmd.getParams();
        Map<String, Object> result = new HashMap<>();

        String typevalue = Util.null2String(params.get("typevalue"));
        if ( StringUtils.isNotBlank(typevalue)){
            if ( typevalue.length() == 7) {
                typevalue = typevalue + "-01";
                DateTimeFormatter dateFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

                // 解析为LocalDate
                LocalDate fullDate = LocalDate.parse(typevalue, dateFormatter);//入参日期
                LocalDate currentDate = LocalDate.now(); // 获取当前日期

                // 将LocalDate对象转换为YearMonth对象
                YearMonth yearMonth1 = YearMonth.from(fullDate);//入参日期
                YearMonth yearMonth2 = YearMonth.from(currentDate);//当前日期

                // 计算月份差值
                long monthsBetween = ChronoUnit.MONTHS.between(yearMonth1, yearMonth2);

                if (monthsBetween > 1 || monthsBetween < 0 ) {
//                result.put("api_status",false);
                    result.put("result",null);
                    result.put("status","-1");
                    result.put("title","我的打卡月历");
                    return result;
                } else {
                    result = nextExecute(cmd);
                }
            } else {
                result = nextExecute(cmd);
                Object resultObj = result.get("result");
                if (!Objects.isNull(resultObj)) {
                    LocalDate currentDate = LocalDate.now();
                    int month = currentDate.getMonthValue();
                    int lastmonth = month - 1;
                    Map<String, Object> resultMap = (Map<String, Object>) resultObj;
                    Map<String, Object> newResultMap = new HashMap<String, Object>();
                    newResultMap.put(lastmonth+"",resultMap.get(lastmonth+""));
                    newResultMap.put(month+"",resultMap.get(month+""));
                    result.put("result",newResultMap);
                }
            }

        }else {
            result = nextExecute(cmd);
        }

        return result;
    }
}
