package com.customization.sskj;

import com.customization.sskj.util.JobGroupUtil;
import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.hrm.cmd.jobset.GetJobDetailCmd;
import com.engine.kq.cmd.myattendance.GetHrmKQMonthReportInfoCmd;
import org.apache.commons.lang.StringUtils;
import weaver.general.Util;

import java.time.LocalDate;
import java.time.YearMonth;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * 获取岗位类别
 */
@CommandDynamicProxy(target = GetJobDetailCmd.class, desc = "GetJobDetailCmd")
public class GetJobDetailCmdInter extends AbstractCommandProxy<Map<String, Object>> {
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> command) {

        GetJobDetailCmd cmd = (GetJobDetailCmd) command;
        Map<String, Object> params = cmd.getParams();
        Map<String, Object> result = nextExecute(cmd);

        Object datasObj = result.get("datas");
        if ( datasObj != null) {
            String jobGroupDesc = "";
            String jobGroupId =  Util.null2String(params.get("jobGroupid"));
            if ( StringUtils.isNotBlank(jobGroupId)) {
                JobGroupUtil jobGroupUtil = new JobGroupUtil();
                jobGroupDesc = jobGroupUtil.getDesc(jobGroupId);
            }
            List< Map< String, Object>> datas = (List< Map< String, Object>>) datasObj;
            Map< String, Object> data = new HashMap<>();
            data.put("label", "类别描述");
            data.put("value", jobGroupDesc);
            datas.add(data);
        }

        return result;
    }
}
