package com.customization.sskj;

import com.api.browser.bean.SearchConditionItem;
import com.api.browser.util.ConditionType;
import com.customization.sskj.util.JobGroupUtil;
import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.hrm.cmd.jobset.GetJobDetailCmd;
import com.engine.hrm.cmd.jobset.GetJobGroupFormCmd;
import org.apache.commons.lang.StringUtils;
import weaver.general.Util;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 获取岗位类别
 */
@CommandDynamicProxy(target = GetJobGroupFormCmd.class, desc = "GetJobGroupFormCmd")
public class GetJobGroupFormCmdInter extends AbstractCommandProxy<Map<String, Object>> {
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> command) {

        GetJobGroupFormCmd cmd = (GetJobGroupFormCmd) command;
        Map<String, Object> params = cmd.getParams();
        Map<String, Object> result = nextExecute(cmd);

        Object conditionObj = result.get("condition");
        if ( conditionObj != null) {
            List< Map<String ,Object>> condition = (List< Map<String ,Object>>) conditionObj;
            Map<String, Object> con = condition.get(0);
            Object itemsObj = con.get("items");
            if ( itemsObj != null) {
                List<SearchConditionItem> items = (List<SearchConditionItem>) itemsObj;
                SearchConditionItem conditionItem = new SearchConditionItem();
                conditionItem.setConditionType(ConditionType.INPUT);
                conditionItem.setLabel("类别描述");
                String[] domKey = new String[] {"jobgroupdesc"};
                conditionItem.setDomkey(domKey);
                conditionItem.setViewAttr(2);
                //判断是新建还是编辑
                String jobGroupId = Util.null2String(params.get("jobgroupid"));
                if (StringUtils.isEmpty(jobGroupId)) {
                    conditionItem.setValue("");
                } else {
                    String jobGroupDesc = "";
                    JobGroupUtil jobGroupUtil = new JobGroupUtil();
                    jobGroupDesc = jobGroupUtil.getDesc(jobGroupId);
                    conditionItem.setValue(jobGroupDesc);
                }
                items.add(conditionItem);
            }
        }

        return result;
    }
}
