package com.engine.sskj.controller;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.google.gson.Gson;
import com.engine.sskj.service.EntryService;
import com.engine.sskj.service.impl.EntryServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

public class EntryController {

    public EntryService getEntryService(User user) {
        return ServiceUtil.getService(EntryServiceImpl.class,user);
    }

    @POST
    @Path("/checkblacklist")
    @Produces(MediaType.APPLICATION_JSON)
    public String checkBlackList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getEntryService(user).checkBlackList(params);
        return  new Gson().toJson(resultDatas);
    }

    @POST
    @Path("/checkentrystatus")
    @Produces(MediaType.APPLICATION_JSON)
    public String checkEntryStatus(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getEntryService(user).checkEntryStatus(params);
        return  new Gson().toJson(resultDatas);
    }

    @POST
    @Path("/grantNumber")
    @Produces(MediaType.APPLICATION_JSON)
    public String grantNumber(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getEntryService(user).grantNumber(params);
        return  new Gson().toJson(resultDatas);
    }


}
