package weaver.haikang.cronjob;

import cn.hutool.core.date.DateUtil;
import com.weaver.file.Prop;
import weaver.conn.RecordSet;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.Util;
import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * 定时合计 内推奖励台账  盛世科技
 */
public class InternalReferralRewardService{
    private final Logger log = LoggerFactory.getLogger(InternalReferralRewardService.class);

    private static final String ntjljmid = Prop.getPropValue("jiangshixinchou","ntjlhjjmid");

    private static final String ntjltzjmid = Prop.getPropValue("jiangshixinchou","ntjltzjmid");

    public synchronized void execute(String currentYm,String nowNy) {
        log.error("howec::::::合计内推奖励月份:"+currentYm);
        RecordSet recordSeta = new RecordSet();
        RecordSet recordSetb = new RecordSet();
        RecordSet recordSetc = new RecordSet();
        RecordSet recordSetd= new RecordSet();
        RecordSet recordSete = new RecordSet();
        RecordSet recordSetf = new RecordSet();
        RecordSet recordSetg = new RecordSet();
        //内推记录有并且已经入职的人员
        String sql2 = "select b.id as uid,a.btjrxm,a.sfzhm,a.tjr,a.tjgw,b.companystartdate,c.rz,c.zz,c.rzbn,b.status from uf_ntjl a inner join hrmresource b on a.btjrxm = b.lastname " +
                "and a.sfzhm = b.certificatenum inner join uf_gwtjjlgz c on a.tjrylb = c.tjgw where b.status in (0,1,2,3) ";
        recordSeta.executeQuery(sql2);
        log.error("howec::::::sql2:"+sql2);
        while (recordSeta.next()) {
            /**
             * 奖励类型
             * 1 入职
             * 2 转正
             * 3 入职半年
             */
            String btjrxm = recordSeta.getString("btjrxm");//被推荐人姓名
            String sfzhm = recordSeta.getString("sfzhm");//被推荐人身份证号
            String tjr = recordSeta.getString("tjr");//推荐人
            String tjgw = recordSeta.getString("tjgw");//推荐岗位
            String companystartdate = recordSeta.getString("companystartdate");//入职日期
            Double rz = recordSeta.getDouble("rz");//入职
            Double zz = recordSeta.getDouble("zz");//转正
            Double rzbn = recordSeta.getDouble("rzbn");//入职半年
            String uid = recordSeta.getString("uid");

            if(getSums2(recordSete,tjr,currentYm)){//如果存在
                log.error("当前推荐人:"+tjr+" 在"+currentYm+" 已经执行过合计,一个月合计一次!");
            }else {
                Double result = 0d;
                //判断 当前岗位当前推荐人,被推荐人,当前奖励类型是否已经发放工资
                //以下奖励 都是针对被推荐人
                String statusstr = "";
                //先发一笔入职
                if(!getJudgeResult(1,tjr,sfzhm,recordSetb)) {//如果不存在,处理
                    result+=rz;
                    statusstr = statusstr+"1,";
                    log.error("howec:::::::::::入职奖励新增");
                    //记录入职奖励
                    insertRzRecord(recordSetc,tjr,1,rz,tjgw,btjrxm,sfzhm);
                }
                //判断员工状态是否存在转正,存在则给一笔转正钱
                if(isExistZz(recordSetg,uid)) {
                    if(!getJudgeResult(2,tjr,sfzhm,recordSetb)) {//如果不存在,处理
                        result+=zz;
                        statusstr = statusstr+"2,";
                        log.error("howec:::::::::::转正奖励新增");
                        //记录转正奖励
                        insertRzRecord(recordSetc,tjr,2,zz,tjgw,btjrxm,sfzhm);
                    }
                }

                //判断员工在职期间和入职时间差 大于180天则给奖励3
                if(!getJudgeResult(3,tjr,sfzhm,recordSetb)) {//如果不存在,处理
                    //判断当前日期是否大于180天
                    Date nowTime = parseDateBystr(nowNy);
                    Date beforeTime = parseDateBystr(companystartdate);
                    if(dataCompare(nowTime,beforeTime)){
                        result+=rzbn;
                        statusstr = statusstr+"3,";
                        log.error("howec:::::::::::入职半年新增");
                        insertRzRecord(recordSetc,tjr,3,rzbn,tjgw,btjrxm,sfzhm);
                    }
                }

                if(result > 0d) {
                    if(statusstr.length()>0) {
                        log.error("xxxxxxxxxxxxxxxxxxx:"+statusstr);
                        statusstr = statusstr.substring(0,statusstr.length()-1);
                        String zzrq = getZzrq(recordSetf,uid);
                        insertJlRecord(recordSetd,currentYm,tjr,result,uid,companystartdate,zzrq,statusstr);
                    }
                }
            }
        }
    }

    //根据userid获取转正日期
    private String getZzrq(RecordSet recordSetf,String uid) {
        String sql = "select count(id) as sums from hrmstatushistory where resourceid = "+uid+" and type_n = 2";
        log.error("howec::::::sql3:"+sql);
        recordSetf.executeQuery(sql);
        recordSetf.next();
        int sums = recordSetf.getInt("sums");
        if(sums > 0) {
            sql = "select changedate from hrmstatushistory where resourceid = "+uid+" and type_n = 2";
            log.error("howec::::::sql4:"+sql);
            recordSetf.executeQuery(sql);
            recordSetf.next();
            return recordSetf.getString("changedate");
        }else {
            return "";
        }
    }

    //判断员工是否存在转正
    private Boolean isExistZz(RecordSet recordSetg, String uid) {
        String sql = "select count(id) as sums from hrmstatushistory where resourceid = "+uid+" and type_n = 2";
        log.error("howec::::::sql3:"+sql);
        recordSetg.executeQuery(sql);
        recordSetg.next();
        int sums = recordSetg.getInt("sums");
        return sums >0;
    }

    //判断推荐人  被推荐人  的奖励类型
    private Boolean getJudgeResult(int type,String tjr,String btjrsfzh,RecordSet recordSetb) {
        String sql = "select count(id) as nums from uf_neituijiangli where tjr = '"+tjr+"' and jllx = "+type+" and btjrsfzh = '"+btjrsfzh+"'";
        log.error("howec::::::sql5:"+sql);
        recordSetb.executeQuery(sql);
        recordSetb.next();
        int nums = recordSetb.getInt("nums");
        return nums> 0;
    }

    //新增台账合计记录
    private void insertJlRecord(RecordSet recordSetd,String ny,String tjr,Double jlje,String btjrxm,String rzrq,String zzrq,String bz) {
        String sql = "insert into uf_ntjlb(ny,tjr,jlje,btjrxm,rzrq,zzrq,bz,formmodeid,modedatacreater,modedatacreatertype,modedatacreatedate,modedatacreatetime) values(?,?,?,?,?,?,?,?,?,?,?,?)";
        recordSetd.executeUpdate(sql,ny,tjr,jlje,btjrxm,rzrq,zzrq,bz,
                ntjltzjmid,"1","0", DateUtil.today(),DateUtil.formatTime(new Date()));

        String idSql = "SELECT max(id) as mid from uf_neituijiangli order by id desc";
        recordSetd.executeQuery(idSql);
        recordSetd.next();
        String id = recordSetd.getString("mid");
        // 权限重构
        permissionReconstruction(Util.getIntValue(id),Integer.parseInt(ntjltzjmid));
    }

    private Boolean getSums2(RecordSet recordSetce,String tjr,String currentYm) {
        String sql = "select count(id) as nums from uf_ntjlb where tjr = '"+tjr+"' and ny = '"+currentYm+"'";
        log.error("howec::::::sql6:"+sql);
        recordSetce.executeQuery(sql);
        recordSetce.next();
        int sums = recordSetce.getInt("nums");
        return sums>0;
    }

    private void insertRzRecord(RecordSet recordSetc,String tjr,int jllx,Double jlje,String tjgw,String btjr,String btjrsfzh) {
        String sql = "insert into uf_neituijiangli(tjr,jllx,jlje,tjgw,btjr,btjrsfzh,formmodeid,modedatacreater,modedatacreatertype,modedatacreatedate,modedatacreatetime) values(?,?,?,?,?,?,?,?,?,?,?)";
        recordSetc.executeUpdate(sql,tjr,jllx,jlje,tjgw,btjr,btjrsfzh,
                ntjljmid,"1","0", DateUtil.today(),DateUtil.formatTime(new Date()));
        String idSql = "SELECT max(id) as mid from uf_neituijiangli order by id desc";
        recordSetc.executeQuery(idSql);
        recordSetc.next();
        log.error("howeccccccc:"+idSql);
        String id = recordSetc.getString("mid");
        // 权限重构
        permissionReconstruction(Util.getIntValue(id),Integer.parseInt(ntjljmid));
    }

    /**
     * 权限重构
     * @param billId
     */
    private void permissionReconstruction(int billId,int jmid) {
        ModeRightInfo ModeRightInfo = new ModeRightInfo();
        ModeRightInfo.setNewRight(true);
        ModeRightInfo.editModeDataShare(1, Util.getIntValue(jmid),billId);
    }

    public Date parseDateBystr(String str) {
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {
            Date date1 = format.parse(str);
            return date1;
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 日期比较
     */
    public static Boolean dataCompare(Date nowdate, Date beforedate) {
        // 获取当前日期
        Calendar currentCalendar = Calendar.getInstance();
        currentCalendar.setTime(nowdate);
        Date currentDate = currentCalendar.getTime();
        // 设置比较日期
        Calendar compareCalendar = Calendar.getInstance();
        compareCalendar.setTime(beforedate);
        Date compareDate = compareCalendar.getTime();

        // 判断当前日期是否大于比较日期半年
        Calendar halfYearLater = Calendar.getInstance();
        halfYearLater.setTime(compareDate);
        halfYearLater.add(Calendar.MONTH, 6); // 增加6个月
        Date halfYearLaterDate = halfYearLater.getTime();

        if (currentDate.after(halfYearLaterDate)) {
           return true;
        } else {
           return false;
        }
    }
}
