package weaver.haikang.cronjob;

import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;
import weaver.interfaces.schedule.BaseCronJob;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

/**
 * 定时合计 内推奖励台账  盛世科技
 */
public class InternalReferralRewardsCron  extends BaseCronJob {
    private final Logger log = LoggerFactory.getLogger(InternalReferralRewardsCron.class);

    @Override
    public void execute() {
        log.error("内推奖励台账定时任务开启-------");
        new Thread( ()->{
            String currentNy = getCurrentNy();
            String nowNy = getNowNy();
            InternalReferralRewardService internalReferralRewardService = new InternalReferralRewardService();
            internalReferralRewardService.execute(currentNy,nowNy);
        }).start();
        log.error("内推奖励台账定时任务结束-------");
    }

    //获取当前时间的上一个月
    private String  getCurrentNy() {
        LocalDate currentDate = LocalDate.now();
        LocalDate previousMonth = currentDate.minusMonths(1);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM");
        String previousMonthString = previousMonth.format(formatter);
        return previousMonthString;
    }


    private  String getNowNy() {
        LocalDate currentDate = LocalDate.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM");
        String previousMonthString = currentDate.format(formatter);
        return previousMonthString+"-01";
    }
}
