package weaver.haikang.cronjob;

import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;
import weaver.interfaces.schedule.BaseCronJob;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

/**
 * 定时合计 讲师津贴
 */
public class LecturerAllowanceCron extends BaseCronJob {
    private final Logger log = LoggerFactory.getLogger(LecturerAllowanceCron.class);

    @Override
    public void execute() {
        log.error("讲师津贴台账定时任务开启-------");
        new Thread( ()->{
            String currentNy = getCurrentNy();
            LectureAllowanceService lectureAllowanceService = new LectureAllowanceService();
            lectureAllowanceService.execute(currentNy);
        }).start();
        log.error("讲师津贴台账定时任务结束-------");
    }

    //获取当前时间的上一个月
    private String  getCurrentNy() {
        LocalDate currentDate = LocalDate.now();
        LocalDate previousMonth = currentDate.minusMonths(1);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM");
        String previousMonthString = previousMonth.format(formatter);
        return previousMonthString;
    }
}
