package weaver.interfaces.sskj.job;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.engine.kq.biz.KQFormatBiz;
import com.engine.kq.timer.KQQueue;
import com.engine.kq.timer.KQTaskBean;
import com.engine.kq.wfset.util.SplitActionUtil;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.jayway.jsonpath.Configuration;
import com.jayway.jsonpath.JsonPath;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.BatchRecordSet;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;

import static weaver.interfaces.sskj.util.HttpsUtil.doPostJsonRequest;


/**
 * Created with IntelliJ IDEA.
 * 获取中控的考勤数据同步至OA
 * @Auther: chenxu
 * @Date: 2023/02/27/14:03
 * @Description:
 */
public class SyncZkKqDataJob extends BaseCronJob {

    @Override
    public void execute() {
        new BaseBean();
        BaseBean bb = new BaseBean();
        bb.writeLog("获取中控的考勤数据同步至OA！！！");
        try {
            //获取所有在职人员的id和workcode
            Map<String, String> idWorkcodeMap = new HashMap<>();
            RecordSet rs = new RecordSet();
            String acqResSql = "SELECT id,workcode FROM HRMRESOURCE WHERE status in (0,1,2,3)";
            rs.executeQuery(acqResSql);
            while (rs.next()){
                String userId = Util.null2String(rs.getString("id"));
                String workcode = Util.null2String(rs.getString("workcode"));
                if ( StringUtils.isNotBlank(userId) && StringUtils.isNotBlank(workcode)) {
                    idWorkcodeMap.put(workcode,userId);
                }
            }
            //获取开始时间结束时间
            Calendar beforeTime = Calendar.getInstance();
            beforeTime.add(Calendar.MINUTE, -5);// 5分钟之前的时间
            Date beforeD = beforeTime.getTime();
            String startTime = DateUtil.format(beforeD,"yyyy-MM-dd HH:mm:ss");
            Date now = new Date();
            String endTime = DateUtil.format(now,"yyyy-MM-dd HH:mm:ss");

            bb.writeLog("startTime:"+startTime);
            bb.writeLog("endTime:"+endTime);
            String url = bb.getPropValue("project_sskj", "zkKqUrl");
//            String url = "http://172.16.50.12:8080/api/v2/transaction/get/?key=28688gxdq7wggprje-nxfdqoqetxe5jscuj0h2bhx2jn";
            bb.writeLog("url:"+url);
            Map<String, String> heads = new HashMap<String, String>();
            Map<String,Object> dataMap = new HashMap<String,Object>();
            dataMap.put("starttime",startTime);
            dataMap.put("endtime",endTime);
            bb.writeLog("获取中控的考勤数据入参dataMap:"+JSONObject.toJSONString(dataMap));
            String back = doPostJsonRequest(url,heads, JSON.toJSONString(dataMap));
            bb.writeLog("urlBack:"+back);
            bb.writeLog("获取中控的考勤数据--response:"+back);
            List<List<Object>> lsParams = new ArrayList<>();
            List<String> lsFormatData = new ArrayList<>();
            Object tempBack = Configuration.defaultConfiguration().jsonProvider().parse(back);
            Integer ret = JsonPath.read(tempBack, "$.ret");
            if ( ret == 0) {
                Integer count = Util.getIntValue(Util.null2String(JsonPath.read(tempBack, "$.data.count").toString()));
                if ( count > 0 ) {
                    List<Map<String, Object>> items = JsonPath.read(tempBack, "$.data.items[*]");
                    for (Map<String, Object> item : items) {
                        String pin = Util.null2String(item.get("pin"));
                        String checktime = Util.null2String(item.get("checktime"));
                        DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                        Date date = df.parse(checktime);
                        DateFormat df2 = new SimpleDateFormat("yyyy-MM-dd");
                        DateFormat df3 = new SimpleDateFormat("HH:mm:ss");
                        Integer isimport = 1;
                        String userid = idWorkcodeMap.get(pin);
                        Integer usertype = 1;
                        String signDate = df2.format(date);
                        String signTime = df3.format(date);
                        Integer isincom = 1;
                        String signfrom = "OutDataSourceSyn";
                        String addr = "";
                        List<Object> params = new ArrayList<>();
                        params.add(userid);
                        params.add(usertype);
                        params.add(signDate);
                        params.add(signTime);
                        params.add("");
                        params.add(isincom);
                        params.add(isimport);
                        params.add(signfrom);
                        params.add("");
                        params.add("");
                        params.add(addr);
                        params.add("中控考勤机");
                        lsParams.add(params);
                        String formatData = userid + "|" + signDate + "|" + signTime;
                        if (!lsFormatData.contains(formatData)) {
                            lsFormatData.add(formatData);
                        }
                    }
                }
            }
            bb.writeLog("lsParams:"+JSON.toJSONString(lsParams));
            bb.writeLog("lsFormatData:"+JSON.toJSONString(lsFormatData));

            Map<String,List<String>> overtimeMap = Maps.newHashMap();
            List<String> overtimeList = Lists.newArrayList();
            List<Object> formatParams = null;
            List<List<Object>> lsFormatParams = new ArrayList<>();
            List<Object> delParams = null;
            List<List<Object>> lsDelParams = new ArrayList<>();

            bb.writeLog("准备刷新报表数据");
            //刷新报表数据
            for(int i=0;lsFormatData!=null&&i<lsFormatData.size();i++){
                formatParams = new ArrayList<>();
                String[] formatData = Util.splitString(lsFormatData.get(i),"|");
                String date_1 = weaver.common.DateUtil.addDate(formatData[1], -1);
                formatParams.add(formatData[0]);
                formatParams.add(date_1);
                lsFormatParams.add(formatParams);

                formatParams = new ArrayList<>();
                formatParams.add(formatData[0]);
                formatParams.add(formatData[1]);
                lsFormatParams.add(formatParams);

                delParams = new ArrayList<>();
                delParams.add(formatData[0]);
                delParams.add(formatData[1]);
                delParams.add(formatData[2]);
                lsDelParams.add(delParams);

                String resourceId = formatData[0];
                String kqdate = formatData[1];
                if(overtimeMap.containsKey(resourceId)){
                    List<String> tmp_overtimeList = overtimeMap.get(resourceId);
                    if(!tmp_overtimeList.contains(kqdate)){
                        tmp_overtimeList.add(kqdate);
                    }
                }else{
                    if(!overtimeList.contains(kqdate)){
                        overtimeList.add(kqdate);
                    }
                    overtimeMap.put(resourceId, overtimeList);
                }
            }

            String sql = "";
            BatchRecordSet bRs = new BatchRecordSet();
            bb.writeLog("开始同步数据");

            //删除本次同步数据
            sql = " delete from hrmschedulesign where signfrom='OutDataSourceSyn' and userid =? and signdate = ? and signtime = ? ";
            bRs.executeBatchSql(sql, lsDelParams);

            sql = " insert into HrmScheduleSign (userid, usertype, signdate, signtime, clientaddress, isincom, isimport, signfrom, longitude, latitude, addr,memo) "
                    + " values(?,?,?,?,?,?,?,?,?,?,?,?)";
            bRs.executeBatchSql(sql,lsParams);

            new KQFormatBiz().format(lsFormatParams);

            bb.writeLog("开始处理加班生成");
            //处理加班生成
            List<KQTaskBean> tasks = new ArrayList<>();
            for(Map.Entry<String, List<String>> mme: overtimeMap.entrySet()){
                String resid = mme.getKey();
                List<String> overList = mme.getValue();
                for(String date : overList){
                    SplitActionUtil.pushOverTimeTasks(date,date,resid,tasks);
                }
            }
            if(!tasks.isEmpty()){
                KQQueue.writeTasks(tasks);
            }

        } catch (Exception e) {
            e.printStackTrace();
            bb.writeLog(e);
            bb.writeLog("获取中控的考勤数据同步至OA--error"+e.getMessage());
        }
    }

}
